## wasi-libc 0.0~git20200319.9efc2f4

=== Makefile ===
# These variables are specifically meant to be overridable via
# the make command-line.
WASM_CC ?= clang
WASM_NM ?= $(patsubst %clang,%llvm-nm,$(WASM_CC))
WASM_AR ?= $(patsubst %clang,%llvm-ar,$(WASM_CC))
WASM_CFLAGS ?= -O2 -DNDEBUG
# The directory where we build the sysroot.
SYSROOT ?= $(CURDIR)/sysroot
# A directory to install to for "make install".
INSTALL_DIR ?= /usr/local
# single or posix
THREAD_MODEL = single
# yes or no
BUILD_DLMALLOC = yes
BUILD_LIBC_BOTTOM_HALF = yes
BUILD_LIBC_TOP_HALF = yes
# The directory where we're store intermediate artifacts.
OBJDIR = $(CURDIR)/build

# Check dependencies.
ifeq ($(BUILD_LIBC_TOP_HALF),yes)
ifneq ($(BUILD_LIBC_BOTTOM_HALF),yes)
$(error BUILD_LIBC_TOP_HALF=yes depends on BUILD_LIBC_BOTTOM_HALF=yes)
endif
endif
ifeq ($(BUILD_LIBC_BOTTOM_HALF),yes)
ifneq ($(BUILD_DLMALLOC),yes)
$(error BUILD_LIBC_BOTTOM_HALF=yes depends on BUILD_DLMALLOC=yes)
endif
endif

# These variables describe the locations of various files and
# directories in the source tree.
BASICS_DIR = $(CURDIR)/basics
BASICS_INC = $(BASICS_DIR)/include
BASICS_CRT_SOURCES = $(wildcard $(BASICS_DIR)/crt/*.c)
BASICS_SOURCES = \
    $(wildcard $(BASICS_DIR)/sources/*.c) \
    $(wildcard $(BASICS_DIR)/sources/math/*.c)
DLMALLOC_DIR = $(CURDIR)/dlmalloc
DLMALLOC_SRC_DIR = $(DLMALLOC_DIR)/src
DLMALLOC_SOURCES = $(DLMALLOC_SRC_DIR)/dlmalloc.c
DLMALLOC_INC = $(DLMALLOC_DIR)/include
LIBC_BOTTOM_HALF_DIR = $(CURDIR)/libc-bottom-half
LIBC_BOTTOM_HALF_CLOUDLIBC_SRC = $(LIBC_BOTTOM_HALF_DIR)/cloudlibc/src
LIBC_BOTTOM_HALF_CLOUDLIBC_SRC_INC = $(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC)/include
LIBC_BOTTOM_HALF_HEADERS_PUBLIC = $(LIBC_BOTTOM_HALF_DIR)/headers/public
LIBC_BOTTOM_HALF_HEADERS_PRIVATE = $(LIBC_BOTTOM_HALF_DIR)/headers/private
LIBC_BOTTOM_HALF_LIBPREOPEN_DIR = $(LIBC_BOTTOM_HALF_DIR)/libpreopen
LIBC_BOTTOM_HALF_SOURCES = $(LIBC_BOTTOM_HALF_DIR)/sources
LIBC_BOTTOM_HALF_ALL_SOURCES = \
    $(shell find $(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC) -name \*.c) \
    $(LIBC_BOTTOM_HALF_LIBPREOPEN_DIR)/libpreopen.c \
    $(shell find $(LIBC_BOTTOM_HALF_SOURCES) -name \*.c)
LIBWASI_EMULATED_MMAN_SOURCES = \
    $(shell find $(LIBC_BOTTOM_HALF_DIR)/mman -name \*.c)
LIBC_BOTTOM_HALF_CRT_SOURCES = $(wildcard $(LIBC_BOTTOM_HALF_DIR)/crt/*.c)
LIBC_TOP_HALF_DIR = $(CURDIR)/libc-top-half
LIBC_TOP_HALF_MUSL_DIR = $(LIBC_TOP_HALF_DIR)/musl
LIBC_TOP_HALF_MUSL_SRC_DIR = $(LIBC_TOP_HALF_MUSL_DIR)/src
LIBC_TOP_HALF_MUSL_INC = $(LIBC_TOP_HALF_MUSL_DIR)/include
LIBC_TOP_HALF_MUSL_SOURCES = \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/a64l.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/basename.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/dirname.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/ffs.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/ffsl.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/ffsll.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/fmtmsg.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/getdomainname.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/gethostid.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/getopt.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/getopt_long.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/getsubopt.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/uname.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/misc/nftw.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/errno/strerror.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/network/htonl.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/network/htons.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/network/ntohl.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/network/ntohs.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/network/inet_ntop.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/network/inet_pton.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/network/inet_aton.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/network/in6addr_any.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/network/in6addr_loopback.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/fenv/fenv.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/fenv/fesetround.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/fenv/feupdateenv.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/fenv/fesetexceptflag.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/fenv/fegetexceptflag.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/fenv/feholdexcept.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/exit/exit.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/exit/atexit.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/exit/assert.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/exit/quick_exit.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/exit/at_quick_exit.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/strftime.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/asctime.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/asctime_r.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/ctime.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/ctime_r.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/wcsftime.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/strptime.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/difftime.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/timegm.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/ftime.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/gmtime.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/gmtime_r.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/timespec_get.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/getdate.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/localtime.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/localtime_r.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/mktime.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/__tm_to_secs.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/__month_to_secs.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/__secs_to_tm.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/__year_to_secs.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/time/__tz.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/fcntl/creat.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/dirent/alphasort.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/dirent/versionsort.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/env/clearenv.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/env/getenv.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/env/putenv.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/env/setenv.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/env/unsetenv.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/unistd/posix_close.c \
    $(filter-out %/procfdname.c %/syscall.c %/syscall_ret.c %/vdso.c %/version.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/internal/*.c)) \
    $(filter-out %/flockfile.c %/funlockfile.c %/__lockfile.c %/ftrylockfile.c \
                 %/rename.c \
                 %/tmpnam.c %/tmpfile.c %/tempnam.c \
                 %/popen.c %/pclose.c \
                 %/remove.c \
                 %/gets.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/*.c)) \
    $(filter-out %/strsignal.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/string/*.c)) \
    $(filter-out %/dcngettext.c %/textdomain.c %/bind_textdomain_codeset.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/locale/*.c)) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/search/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/multibyte/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/regex/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/prng/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/conf/*.c) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/ctype/*.c) \
    $(filter-out %/__signbit.c %/__signbitf.c %/__signbitl.c \
                 %/__fpclassify.c %/__fpclassifyf.c %/__fpclassifyl.c \
                 %/ceilf.c %/ceil.c \
                 %/floorf.c %/floor.c \
                 %/truncf.c %/trunc.c \
                 %/rintf.c %/rint.c \
                 %/nearbyintf.c %/nearbyint.c \
                 %/sqrtf.c %/sqrt.c \
                 %/fabsf.c %/fabs.c \
                 %/copysignf.c %/copysign.c \
                 %/fminf.c %/fmaxf.c \
                 %/fmin.c %/fmax.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/math/*.c)) \
    $(filter-out %/crealf.c %/creal.c \
                 %/cimagf.c %/cimag.c, \
                 $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/complex/*.c)) \
    $(wildcard $(LIBC_TOP_HALF_MUSL_SRC_DIR)/crypt/*.c)
MUSL_PRINTSCAN_SOURCES = \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/internal/floatscan.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfprintf.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfwprintf.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdio/vfscanf.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/strtod.c \
    $(LIBC_TOP_HALF_MUSL_SRC_DIR)/stdlib/wcstod.c
LIBC_TOP_HALF_HEADERS_PRIVATE = $(LIBC_TOP_HALF_DIR)/headers/private
LIBC_TOP_HALF_SOURCES = $(LIBC_TOP_HALF_DIR)/sources
LIBC_TOP_HALF_ALL_SOURCES = \
    $(LIBC_TOP_HALF_MUSL_SOURCES) \
    $(shell find $(LIBC_TOP_HALF_SOURCES) -name \*.c)

# Set the target variables. Multiarch triples notably omit the vendor
# field, which happens to be what we do for the main target triple too.
TARGET_TRIPLE = wasm32-wasi
MULTIARCH_TRIPLE = wasm32-wasi

# These variables describe the locations of various files and
# directories in the generated sysroot tree.
SYSROOT_LIB = $(SYSROOT)/lib/$(MULTIARCH_TRIPLE)
SYSROOT_INC = $(SYSROOT)/include
SYSROOT_SHARE = $(SYSROOT)/share/$(MULTIARCH_TRIPLE)

# Set the target.
override WASM_CFLAGS += --target=$(TARGET_TRIPLE)
# WebAssembly floating-point match doesn't trap.
# TODO: Add -fno-signaling-nans when the compiler supports it.
override WASM_CFLAGS += -fno-trapping-math

# Configure support for threads.
ifeq ($(THREAD_MODEL), single)
override WASM_CFLAGS += -mthread-model single
endif
ifeq ($(THREAD_MODEL), posix)
override WASM_CFLAGS += -mthread-model posix -pthread
endif

# Set the sysroot.
override WASM_CFLAGS += --sysroot="$(SYSROOT)"

objs = $(patsubst $(CURDIR)/%.c,$(OBJDIR)/%.o,$(1))
override BASICS_OBJS = $(call objs,$(BASICS_SOURCES))
override DLMALLOC_OBJS = $(call objs,$(DLMALLOC_SOURCES))
override LIBC_BOTTOM_HALF_ALL_OBJS = $(call objs,$(LIBC_BOTTOM_HALF_ALL_SOURCES))
override LIBC_TOP_HALF_ALL_OBJS = $(call objs,$(LIBC_TOP_HALF_ALL_SOURCES))
override LIBC_OBJS := $(BASICS_OBJS)
ifeq ($(BUILD_DLMALLOC),yes)
override LIBC_OBJS += $(DLMALLOC_OBJS)
endif
ifeq ($(BUILD_LIBC_BOTTOM_HALF),yes)
# Override basics' string.o with libc-bottom-half's.
override LIBC_OBJS := $(filter-out %/string.o,$(LIBC_OBJS))
# Add libc-bottom-half's objects.
override LIBC_OBJS += $(LIBC_BOTTOM_HALF_ALL_OBJS)
endif
ifeq ($(BUILD_LIBC_TOP_HALF),yes)
# Override libc-bottom-half's string.o with libc-top-half's.
override LIBC_OBJS := $(filter-out %/string.o,$(LIBC_OBJS))
# Override libc-bottom-half's qsort.o with libc-top-half's.
override LIBC_OBJS := $(filter-out %/qsort.o,$(LIBC_OBJS))
# libc-top-half is musl.
override LIBC_OBJS += $(LIBC_TOP_HALF_ALL_OBJS)
endif
override MUSL_PRINTSCAN_OBJS = $(call objs,$(MUSL_PRINTSCAN_SOURCES))
override MUSL_PRINTSCAN_LONG_DOUBLE_OBJS = $(patsubst %.o,%.long-double.o,$(MUSL_PRINTSCAN_OBJS))
override MUSL_PRINTSCAN_NO_FLOATING_POINT_OBJS = $(patsubst %.o,%.no-floating-point.o,$(MUSL_PRINTSCAN_OBJS))
override LIBWASI_EMULATED_MMAN_OBJS = $(call objs,$(LIBWASI_EMULATED_MMAN_SOURCES))

# Files from musl's include directory that we don't want to install in the
# sysroot's include directory.
override MUSL_OMIT_HEADERS :=

# Remove files which aren't headers (we generate alltypes.h below).
override MUSL_OMIT_HEADERS += \
    "bits/syscall.h.in" \
    "bits/alltypes.h.in" \
    "alltypes.h.in"

# Use the compiler's version of these headers.
override MUSL_OMIT_HEADERS += \
    "stdarg.h" \
    "stddef.h"

# Use the WASI errno definitions.
override MUSL_OMIT_HEADERS += \
    "bits/errno.h"

# Remove headers that aren't supported yet or that aren't relevant for WASI.
override MUSL_OMIT_HEADERS += \
    "sys/procfs.h" \
    "sys/user.h" \
    "sys/kd.h" "sys/vt.h" "sys/soundcard.h" "sys/sem.h" \
    "sys/shm.h" "sys/msg.h" "sys/ipc.h" "sys/ptrace.h" \
    "sys/statfs.h" \
    "bits/kd.h" "bits/vt.h" "bits/soundcard.h" "bits/sem.h" \
    "bits/shm.h" "bits/msg.h" "bits/ipc.h" "bits/ptrace.h" \
    "bits/statfs.h" \
    "sys/vfs.h" \
    "sys/statvfs.h" \
    "syslog.h" "sys/syslog.h" \
    "wait.h" "sys/wait.h" \
    "ucontext.h" "sys/ucontext.h" \
    "paths.h" \
    "utmp.h" "utmpx.h" \
