=== debian/changelog ===
wasi-libc (0.0~git20200319.9efc2f4-2) unstable; urgency=medium

  * Update to LLVM 10.

 -- Ximin Luo <infinity0@debian.org>  Wed, 05 Aug 2020 21:52:23 +0100

wasi-libc (0.0~git20200319.9efc2f4-1) unstable; urgency=medium

  * New upstream version needed by rustc 1.44.1.

 -- Ximin Luo <infinity0@debian.org>  Sat, 04 Jul 2020 17:25:29 +0100

wasi-libc (0.0~git20200114.1fad338-1) unstable; urgency=medium

  * New upstream version needed by rustc 1.42.0.

 -- Ximin Luo <infinity0@debian.org>  Sat, 04 Apr 2020 02:54:16 +0100

wasi-libc (0.0~git20191220.a280fea-2) unstable; urgency=medium

  * Mark as M-A: foreign for cross-compiling.

 -- Ximin Luo <infinity0@debian.org>  Sat, 04 Apr 2020 01:12:55 +0100

wasi-libc (0.0~git20191220.a280fea-1) unstable; urgency=medium

  * Initial release.

 -- Ximin Luo <infinity0@debian.org>  Sun, 08 Mar 2020 22:38:19 +0000
