=== debian/changelog ===
wasi-libc (0.0~git20200731.215adc8-2) unstable; urgency=medium

  * Update to LLVM 11. (Closes: #974787)

 -- Ximin Luo <infinity0@debian.org>  Tue, 01 Dec 2020 20:03:39 +0000

wasi-libc (0.0~git20200731.215adc8-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Sat, 07 Nov 2020 20:58:46 +0000

wasi-libc (0.0~git20200731.215adc8-1~exp1) experimental; urgency=medium

  * New upstream version needed by rustc 1.47.0.

 -- Ximin Luo <infinity0@debian.org>  Fri, 04 Sep 2020 17:29:07 +0100
