## wasi-libc 0.0~git20201130.5879558

=== Makefile ===
--- 
+++ 
@@ -44,6 +44,14 @@
 LIBC_BOTTOM_HALF_ALL_SOURCES = \
     $(shell find $(LIBC_BOTTOM_HALF_CLOUDLIBC_SRC) -name \*.c) \
     $(shell find $(LIBC_BOTTOM_HALF_SOURCES) -name \*.c)
+
+# FIXME(https://reviews.llvm.org/D85567) - due to a bug in LLD the weak
+# references to a function defined in `chdir.c` only work if `chdir.c` is at the
+# end of the archive, but once that LLD review lands and propagates into LLVM
+# then we don't have to do this.
+LIBC_BOTTOM_HALF_ALL_SOURCES := $(filter-out $(LIBC_BOTTOM_HALF_SOURCES)/chdir.c,$(LIBC_BOTTOM_HALF_ALL_SOURCES))
+LIBC_BOTTOM_HALF_ALL_SOURCES := $(LIBC_BOTTOM_HALF_ALL_SOURCES) $(LIBC_BOTTOM_HALF_SOURCES)/chdir.c
+
 LIBWASI_EMULATED_MMAN_SOURCES = \
     $(shell find $(LIBC_BOTTOM_HALF_DIR)/mman -name \*.c)
 LIBWASI_EMULATED_SIGNAL_SOURCES = \
@@ -323,13 +331,3 @@
 	$(WASM_AR) crs $@ $(wordlist 200, 399, $^)
 	$(WASM_AR) crs $@ $(wordlist 400, 599, $^)
 	$(WASM_AR) crs $@ $(wordlist 600, 799, $^)
-	# This might eventually overflow again, but at least it'll do so in a loud way instead of
-	# silently dropping the tail.
-	$(WASM_AR) crs $@ $(wordlist 800, 100000, $^)
-
-$(MUSL_PRINTSCAN_OBJS): WASM_CFLAGS += \
-	    -D__wasilibc_printscan_no_long_double \
-	    -D__wasilibc_printscan_full_support_option="\"add -lc-printscan-long-double to the link command\""
-
-$(MUSL_PRINTSCAN_NO_FLOATING_POINT_OBJS): WASM_CFLAGS += \
-	    -D__wasilibc_printscan_no_floating_point \
