=== debian/changelog ===
wasi-libc (0.0~git20201130.5879558-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Wed, 29 Sep 2021 19:55:26 +0100

wasi-libc (0.0~git20201130.5879558-1~exp1) experimental; urgency=medium

  * New upstream version needed by rustc 1.51.0.

 -- Ximin Luo <infinity0@debian.org>  Wed, 07 Apr 2021 01:43:35 +0100
