=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders: Ximin Luo <infinity0@debian.org>
-Build-Depends: debhelper-compat (= 12), clang-10, llvm-10
+Build-Depends: debhelper-compat (= 12), clang-11, llvm-11
 Standards-Version: 4.4.1
 Homepage: https://github.com/CraneStation/wasi-libc
 Vcs-Browser: https://salsa.debian.org/rust-team/wasi-libc
