## wasi-libc 0.0~git20210922.ad51334

=== debian/changelog ===
wasi-libc (0.0~git20210922.ad51334-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Tue, 08 Mar 2022 10:49:36 +0000

wasi-libc (0.0~git20210922.ad51334-1~exp1) experimental; urgency=medium

  [ Fabian Gruenbichler ]
  * New upstream version needed by rustc 1.57.0

  [ Ximin Luo ]
  * Update to LLVM 13, same as rust. (Closes: #1000910)

 -- Ximin Luo <infinity0@debian.org>  Sun, 06 Mar 2022 21:29:02 +0000
