=== debian/rules ===
--- 
+++ 
@@ -5,9 +5,9 @@
 
 include /usr/share/dpkg/buildflags.mk
 
-export WASM_NM = llvm-nm-11
-export WASM_AR = llvm-ar-11
-export WASM_CC = clang-11
+export WASM_NM = llvm-nm-13
+export WASM_AR = llvm-ar-13
+export WASM_CC = clang-13
 
 # stack protector not yet supported, see
 # https://github.com/CraneStation/wasi-libc/issues/157
